<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<itemFormativoEsercizio nomeDescrittivo="Ricevitore a basso consumo per telecomando a raggi infrarossi" identificatoreArgomento="esercizio39" prerequisiti="digitalInput,digitalOutput,swpowersave" tags="Base,DigitalInput,Software,Risparmio energetico" fondamentale="false" mdPblproblem="false" mdPblnewlearninggoal="false">
    <mdprerequisitelist>Funzionamento del sensore VS1838</mdprerequisitelist>
    <mdprerequisitelist>Interrupt</mdprerequisitelist>
    <mdprerequisitelist>Modalità di risparmio energetico</mdprerequisitelist>
    <mdcomponentlist>ricevitore a raggi infrarossi VS1838</mdcomponentlist>
    <mdcomponentlist>telecomando a raggi infrarossi</mdcomponentlist>
    <mdcomponentlist>resistore 10 kOhm (resistore di pullup)</mdcomponentlist>
    <mdwhy>Quando la fonte di alimentazione è una batteria è importante saper individuare opportunità per l'utilizzo delle modalità di risparmio energetico disponibili e massimizzare così l'autonomia.</mdwhy>
    <mdexpectedresult>Costruire un ricevitore a raggi infrarossi che:&#13;
- consente di accendere e spegnere il led integrato con il telecomando;&#13;
- quando non arriva un segnale per più di 5 secondi entra in modalità a basso consumo e ci rimane fino alla ricezione di un nuovo segnale.</mdexpectedresult>
    <mdextras></mdextras>
    <mderraticbehavior>La scelta di un GPIO non abilitato agli interrupt o non corretto per il risveglio dalla modalità a basso consumo scelta può rendere irreversibile il passaggio in modalità a basso consumo e richiedere il reset per il risveglio.</mderraticbehavior>
    <mdcommonerrors></mdcommonerrors>
    <mdlessonlearned>In questo caso, dato che che l'azione va svolta solo in presenza dell'input dell'utente, e tale input è un segnale esterno che si può può rilevare con gli interrupt, si può utilizzare la modalità power down, o altra modalità equivalente prevista dal microcontrollore utilizzato.</mdlessonlearned>
    <mdsolution>La linea dati del sensore cambia livello logico quando arriva un segnale e si può collegare a un pin abilitato all'utilizzo degli interrupt.&#13;
E' sufficiente mettere il microcontrollore in modalità power down disattivando tutto il possibile (es. per Arduino: LowPower.powerDown(SLEEP_FOREVER, ADC_OFF, BOD_OFF) ) e farlo riattivare sfruttando gli interrupt.</mdsolution>
    <mdpbldetails></mdpbldetails>
</itemFormativoEsercizio>
